
% Written by Dr. Pall Thordarson, School of Chemistry, The Univerity of New
% South Wales, Sydney, NSW 2052 Australia. This code is based on earlier
% work by Jaco de Groot and Macerano Blanco to open Nanoscope 6 files 
% (http://www.mathworks.com/matlabcentral/fileexchange/11515-open-nanoscope-6-afm-images)
% It uses the
% "di_header_find" file from that code.
% The first part of this program gets the file name structure from the user

clear all;
StrA = input ('Enter filename prefix (e.g. Frc_) ','s'); %if it is suspected that host conc.

StrB = input ('Enter first number in sequence of filenames (e.g., 1) ');
StrC = input ('Enter last number in sequence of filenames (e.g., 2141) ');

StrD = input ('Enter the filename you want to use to save the data ','s');

prefx=StrA;
for i = StrB:StrC;
roll=num2str(i);   
file_name=strcat(prefx,roll);
%str2num(file_name(Frc_i));
%file_name='Frc_2'
fid = fopen(file_name,'r');

sHSDC_datalength=di_header_find(file_name,'\Data length:');
fseek(fid,sHSDC_datalength(1),-1);
line=fgets(fid);
datalength(1)=extract_num(line);
fseek(fid,sHSDC_datalength(2),-1);
line=fgets(fid);
datalength(2)=extract_num(line);
fseek(fid,sHSDC_datalength(3),-1);
line=fgets(fid);
datalength(3)=extract_num(line);
dataA=fread(fid,datalength(1)/2, 'int16');

fclose(fid);

retractcurves(:,i-StrB+1)=flipud(dataA(5141:5396));
approachcurves(:,i-StrB+1)=flipud(dataA(4885:5140));
zretract(:,i-StrB+1)=flipud(dataA(5653:5908));

zapproach(:,i-StrB+1)=flipud(dataA(5397:5652));

end
plot(zapproach,approachcurves,'b');
hold on;
plot(zretract,retractcurves,'r');
Xlabel('nm');
Ylabel('pN');
hold off;
save (StrD);